/*!
 * © 2017 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */
/* globals Row, Rank */
/* exported OtherRow */

function OtherRow(cid,rank,companion) {
    Row.call(this,cid);
    
    this._rank = rank;
    this._companion = companion;
    
    this._wks = [];
    this._clubcom = [];
    this._bawdycom = [];
    this._playcom = [];
    for(var i=1; i<5; i++) {
        this._wks[i] = document.getElementById(cid+"-week-"+i);
        this._clubcom[i] = document.getElementById(cid+"-week-"+i+"-club-details-companion");
        this._bawdycom[i] = document.getElementById(cid+"-week-"+i+"-bawdy-details-companion");
        this._playcom[i] = document.getElementById(cid+"-week-"+i+"-play-details-companion");
    }
    this._regchoice = document.getElementById(cid+"-regiment");
    this._prochoice = document.getElementById(cid+"-rank");
    this._text = document.getElementById(cid+"-other-notes");

    this.controlledBy(this._regchoice);
    this.controlledBy(this._prochoice);
    this.controlledBy(this._text);
    for(i=1; i<5; i++) {
        this.controlledBy(this._wks[i]);
        this.controlledBy(this._clubcom[i]);
        this.controlledBy(this._bawdycom[i]);
        this.controlledBy(this._playcom[i]);
    }
    
    this.addInnerHTML(document.getElementById(cid+"-other-notes-effect"));
    this.addDetailsField(document.getElementById(cid+"-form-other-notes"));
    this.addNotesField(document.getElementById(cid+"-form-other-effect"));
    
    this.processChange(this,undefined);
}

OtherRow.prototype = Object.create(Row.prototype);

OtherRow.prototype.processChange = function(self,event) {
    var notes = ""; // Default text

    if (self._inParis.checked) {
        var visits = 0;
        var duties = 0;
        var visitdelta = (self._companion ? 1 : 0);
        for(var i=1; i<5; i++) {
            var chosen = self._wks[i].options[self._wks[i].selectedIndex].text;
            if (chosen === "On Duty") {
                duties++;
            }
            if (chosen === "Visit Club" && self._clubcom[i].checked) {
                visits += visitdelta;
            }
            if (chosen === "Visit Bawdyhouse" && self._bawdycom[i].checked) {
                visits++;
            }
            if (chosen === "Visit playhouse" && self._playcom[i].checked) {
                visits++;
            }
            if (chosen === "Court new female companion") {
                visits += 0.1;
                visitdelta = 0.1;
            }
            if (chosen === "Visit female companion") {
                visits += visitdelta;
            }
        }
        var rank = self._rank;
        if (self._regchoice.selectedIndex > 0) {
            rank = Rank.Private;
        }
        if (self._prochoice.selectedIndex > 0) {
            rank = Rank.forName(self._prochoice.options[self._prochoice.selectedIndex].text);
        }
        if (rank) {
            if (duties === 1) {
                if (rank === Rank.Private) {
                    notes += "As a private you will need permission (granted on a roll of 5 on 1d6) from their battalion commander to skip one week (of the required two weeks) of duty. ";
                }
            } else if (duties === 0) {
                if (rank === Rank.Private) {
                    notes += "As a private you must spend at least one week on duty. ";
                } else if (rank === Rank.Subaltern) {
                    notes += "As a subaltern you will need permission (granted on a roll of 5 on 1d6) from their battalion commander to skip their one week of duty. ";
                }
            }
        }
    
        if (visits === 0) {
            notes += "You have not made a visit to a female companion this month. You will lose two status points (cumulative) for every month in a row that you are without a female companion.";
        } else if (visits < 1) {
            notes += "If your courtship fails you are at risk of being without a female companion this month. If so you will lose two status points (cumulative) for every month in a row that you are without a female companion.";
        }
    } else {
        notes = "";
    }
    
    self.notifyDetails(self._text.value);
    self.notifyCommentary(notes);
};
